/*
 * RegisterAccess.h
 *
 *  Created on: 12.07.2017
 *      Author: LK
 */

#ifndef TMC_HELPERS_REGISTERACCESS_H
#define TMC_HELPERS_REGISTERACCESS_H

	#define	ACCESS_NONE            0
	#define ACCESS_READ            1
	#define ACCESS_WRITE           2
	#define ACCESS_READ_AND_WRITE  3
	#define ACCESS_READ_OR_WRITE   7

	#define IS_READABLE(x)  (x & ACCESS_READ)
	#define IS_WRITEABLE(x) (x & ACCESS_WRITE)

	/* Helper define:
	 * Most register permission arrays are initialised with 128 values.
	 * In those fields its quite hard to have an easy overview of available
	 * registers. For that, ____ is defined to 0, since 4 underscores are
	 * very easy to distiguish from the 2-digit hexadecimal values.
	 * This way, the used registers (permission != ACCESS_NONE) are easily spotted
	 * amongst unused (permission == ACCESS_NONE) registers.
	 */
	#define ____ 0x00
#endif /* TMC_HELPERS_REGISTERACCESS_H */
